package geniusweb.protocol;

import geniusweb.events.CurrentState;

/**
 * Implementation of CurrentState event. This contains NegoState and therefore
 * can not be defined in the events module.
 */
public class CurrentNegoState extends CurrentState {
	private final NegoState state;

	public CurrentNegoState(NegoState state) {
		this.state = state;
	}

	public CurrentNegoState(NegoState state, Long now) {
		super(now);
		this.state = state;
	}

	public NegoState getState() {
		return state;
	}

	@Override
	public String toString() {
		return "CurrentNegoState[" + getTime() + "," + state + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((state == null) ? 0 : state.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		CurrentNegoState other = (CurrentNegoState) obj;
		if (state == null) {
			if (other.state != null)
				return false;
		} else if (!state.equals(other.state))
			return false;
		return true;
	}
}
